package model

import "time"

type PayChannel struct {
	Id               int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Name             string    `json:"name" xorm:"not null comment('渠道名称') VARCHAR(255)"`
	IsUse            int       `json:"is_use" xorm:"not null default 1 comment('是否开启；1：开启；0：关闭') TINYINT(1)"`
	ThirdPartyId     string    `json:"third_party_id" xorm:"not null comment('第三方聚合支付的渠道id') VARCHAR(20)"`
	Kind             string    `json:"kind" xorm:"not null comment('渠道种类(self:自有支付 zhiYing:智莺支付 thirdParty 第三方聚合支付 )') VARCHAR(255)"`
	ModuleIdentifier string    `json:"module_identifier" xorm:"not null comment('模块标识符') VARCHAR(255)"`
	ModuleName       string    `json:"module_name" xorm:"not null comment('模块名称') VARCHAR(255)"`
	CommissionRate   string    `json:"commission_rate" xorm:"not null comment('抽成比例(千分之)') VARCHAR(255)"`
	Memo             string    `json:"memo" xorm:"not null comment('备注') VARCHAR(255)"`
	Ext              string    `json:"ext" xorm:"comment('拓展字段(json存储)') TEXT"`
	CreateAt         time.Time `json:"create_at" xorm:"default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt         time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
