package md

type AliPayPayParams struct {
	Subject   string `json:"subject" binding:"required"`
	Amount    string `json:"amount" binding:"required"`
	OrderType string `json:"order_type" binding:"required"`
	OrdId     string `json:"ord_id"`
}

type PayData struct {
	PayAppCertSn          string `json:"pay_app_cert_sn"`
	PayAlipayRootCertSn   string `json:"pay_alipay_root_cert_sn"`
	PayAlipayrsaPublicKey string `json:"pay_alipayrsa_public_key"`
	PayAliUseType         string `json:"pay_ali_use_type"`
	PriKey                string `json:"pay_ali_new_private_key"`
	WxAppletFilepathUrl   string `json:"wx_applet_filepath_url"`
}

type ZhimaCreditPayafteruseCreditagreementQuery struct {
	ZhimaCreditPayafteruseCreditagreementQueryResponse struct {
		Code              string `json:"code"`
		Msg               string `json:"msg"`
		AgreementStatus   string `json:"agreement_status"`
		BizTime           string `json:"biz_time"`
		CreditAgreementId string `json:"credit_agreement_id"`
		OutAgreementNo    string `json:"out_agreement_no"`
	} `json:"zhima_credit_payafteruse_creditagreement_query_response"`
	AlipayCertSn string `json:"alipay_cert_sn"`
	Sign         string `json:"sign"`
}
type ZhimaCreditPayafteruseCreditbizorderOrder struct {
	ZhimaCreditPayafteruseCreditbizorderOrderResponse struct {
		Code             string `json:"code"`
		Msg              string `json:"msg"`
		OutOrderNo       string `json:"out_order_no"`
		CreditBizOrderId string `json:"credit_biz_order_id"`
	} `json:"zhima_credit_payafteruse_creditbizorder_order_response"`
	Sign string `json:"sign"`
}
type ZhimaCreditPayafteruseCreditbizorderQuery struct {
	ZhimaCreditPayafteruseCreditbizorderQueryResponse struct {
		Code              string  `json:"code"`
		Msg               string  `json:"msg"`
		CreditBizOrderId  string  `json:"credit_biz_order_id"`
		CreditAgreementId string  `json:"credit_agreement_id"`
		TotalAmount       float64 `json:"total_amount"`
		CreateTime        string  `json:"create_time"`
		ZmServiceId       string  `json:"zm_service_id"`
		ProductCode       string  `json:"product_code"`
		OrderStatus       string  `json:"order_status"`
		TradeNo           string  `json:"trade_no"`
	} `json:"zhima_credit_payafteruse_creditbizorder_query_response"`
	Sign string `json:"sign"`
}
type AlipayFundTransUniTransfer struct {
	AlipayFundTransUniTransferResponse struct {
		Code           string `json:"code"`
		Msg            string `json:"msg"`
		OutBizNo       string `json:"out_biz_no"`
		OrderId        string `json:"order_id"`
		PayFundOrderId string `json:"pay_fund_order_id"`
		Status         string `json:"status"`
		TransDate      string `json:"trans_date"`
	} `json:"alipay_fund_trans_uni_transfer_response"`
	Sign string `json:"sign"`
}
type ZhimaCreditPayafteruseCreditbizorderFinish struct {
	ZhimaCreditPayafteruseCreditbizorderFinishResponse struct {
		Code             string `json:"code"`
		Msg              string `json:"msg"`
		OutRequestNo     string `json:"out_request_no"`
		CreditBizOrderId string `json:"credit_biz_order_id"`
		OrderStatus      string `json:"order_status"`
	} `json:"zhima_credit_payafteruse_creditbizorder_finish_response"`
	Sign string `json:"sign"`
}
type AlipayTradePay struct {
	AlipayTradePayResponse struct {
		Code            string  `json:"code"`
		Msg             string  `json:"msg"`
		TradeNo         string  `json:"trade_no"`
		OutTradeNo      string  `json:"out_trade_no"`
		OpenId          string  `json:"open_id"`
		BuyerLogonId    string  `json:"buyer_logon_id"`
		TransPayRate    string  `json:"trans_pay_rate"`
		TotalAmount     float64 `json:"total_amount"`
		TransCurrency   string  `json:"trans_currency"`
		SettleCurrency  string  `json:"settle_currency"`
		SettleAmount    string  `json:"settle_amount"`
		PayCurrency     string  `json:"pay_currency"`
		PayAmount       string  `json:"pay_amount"`
		SettleTransRate string  `json:"settle_trans_rate"`
		ReceiptAmount   string  `json:"receipt_amount"`
		BuyerPayAmount  float64 `json:"buyer_pay_amount"`
		PointAmount     float64 `json:"point_amount"`
		InvoiceAmount   float64 `json:"invoice_amount"`
		GmtPayment      string  `json:"gmt_payment"`
		FundBillList    []struct {
			FundChannel string  `json:"fund_channel"`
			BankCode    string  `json:"bank_code"`
			Amount      int     `json:"amount"`
			RealAmount  float64 `json:"real_amount"`
			FundType    string  `json:"fund_type"`
		} `json:"fund_bill_list"`
		CardBalance         float64 `json:"card_balance"`
		StoreName           string  `json:"store_name"`
		DiscountGoodsDetail string  `json:"discount_goods_detail"`
		BuyerUserId         string  `json:"buyer_user_id"`
		AsyncPaymentMode    string  `json:"async_payment_mode"`
		VoucherDetailList   []struct {
			Id                    string `json:"id"`
			Name                  string `json:"name"`
			Type                  string `json:"type"`
			Amount                int    `json:"amount"`
			MerchantContribute    int    `json:"merchant_contribute"`
			OtherContribute       int    `json:"other_contribute"`
			Memo                  string `json:"memo"`
			TemplateId            string `json:"template_id"`
			OtherContributeDetail []struct {
				ContributeType   string `json:"contribute_type"`
				ContributeAmount int    `json:"contribute_amount"`
			} `json:"other_contribute_detail"`
			PurchaseBuyerContribute    float64 `json:"purchase_buyer_contribute"`
			PurchaseMerchantContribute float64 `json:"purchase_merchant_contribute"`
			PurchaseAntContribute      float64 `json:"purchase_ant_contribute"`
		} `json:"voucher_detail_list"`
		AdvanceAmount       string `json:"advance_amount"`
		AuthTradePayMode    string `json:"auth_trade_pay_mode"`
		ChargeAmount        string `json:"charge_amount"`
		ChargeFlags         string `json:"charge_flags"`
		SettlementId        string `json:"settlement_id"`
		BusinessParams      string `json:"business_params"`
		BuyerUserType       string `json:"buyer_user_type"`
		MdiscountAmount     string `json:"mdiscount_amount"`
		DiscountAmount      string `json:"discount_amount"`
		BuyerUserName       string `json:"buyer_user_name"`
		ReceiptCurrencyType string `json:"receipt_currency_type"`
		CreditPayMode       string `json:"credit_pay_mode"`
		CreditBizOrderId    string `json:"credit_biz_order_id"`
		EnterprisePayInfo   struct {
			IsUseEnterprisePay bool   `json:"is_use_enterprise_pay"`
			InvoiceAmount      int    `json:"invoice_amount"`
			BizInfo            string `json:"biz_info"`
		} `json:"enterprise_pay_info"`
		CanTurnToAppPay string `json:"can_turn_to_app_pay"`
		HybAmount       string `json:"hyb_amount"`
		BkagentRespInfo struct {
			BindtrxId        string `json:"bindtrx_id"`
			BindclrissrId    string `json:"bindclrissr_id"`
			BindpyeracctbkId string `json:"bindpyeracctbk_id"`
			BkpyeruserCode   string `json:"bkpyeruser_code"`
			EstterLocation   string `json:"estter_location"`
		} `json:"bkagent_resp_info"`
		ChargeInfoList struct {
			ChargeFee               float64 `json:"charge_fee"`
			OriginalChargeFee       float64 `json:"original_charge_fee"`
			SwitchFeeRate           string  `json:"switch_fee_rate"`
			IsRatingOnTradeReceiver string  `json:"is_rating_on_trade_receiver"`
			IsRatingOnSwitch        string  `json:"is_rating_on_switch"`
			ChargeType              string  `json:"charge_type"`
			SubFeeDetailList        []struct {
				ChargeFee         float64 `json:"charge_fee"`
				OriginalChargeFee float64 `json:"original_charge_fee"`
				SwitchFeeRate     string  `json:"switch_fee_rate"`
			} `json:"sub_fee_detail_list"`
		} `json:"charge_info_list"`
	} `json:"alipay_trade_pay_response"`
	Sign string `json:"sign"`
}

type AlipayTradeRefund struct {
	AlipayTradeRefundResponse struct {
		Code         string `json:"code"`
		Msg          string `json:"msg"`
		BuyerLogonId string `json:"buyer_logon_id"`
		BuyerUserId  string `json:"buyer_user_id"`
		FundChange   string `json:"fund_change"`
		GmtRefundPay string `json:"gmt_refund_pay"`
		OutTradeNo   string `json:"out_trade_no"`
		RefundFee    string `json:"refund_fee"`
		SendBackFee  string `json:"send_back_fee"`
		TradeNo      string `json:"trade_no"`
		SubMsg       string `json:"sub_msg"`
	} `json:"alipay_trade_refund_response"`
	Sign string `json:"sign"`
}
