package md

const (
	JoinPayUrl            = "https://www.joinpay.com/trade/uniPayApi.action"
	PayTestAccount        = "888118100005250"
	PayTestSecretKey      = "a12ceace4cc5423eae32b4626adf56c9"
	Q1FrpCodeALIPAY       = "ALIPAY_H5"   //支付宝固定
	Q1FrpCodeWEIXINPAYAPP = "WEIXIN_APP3" //微信固定（应该）
	//Q1FrpCodeWEIXINPAYH5 = "WEIXIN_H5_PLUS"
	//Q1FrpCodeWEIXINPAYGZH = "WEIXIN_GZH"
	//Q1FrpCodeWEIXINPAYXCX = "WEIXIN_XCX"
	PayTestAliAccount    = "777146200391877"
	PayTestWeChatAccount = "777196100391173"
	WEIXINPATH           = "/pages/payIndex/payIndex?rc_result="
)

//
//  JoinPayReq
//  @Description: 汇聚支付-聚合支付-支付接口-请求参数信息体
//  @Url: https://www.joinpay.com/open-platform/pages/document.html?apiName=%E8%81%9A%E5%90%88%E6%94%AF%E4%BB%98&id=6
//
type JoinPayReq struct {
	P0Version     string `json:"p0_Version" label:"版本号;目前版本号为：2.1;是"`
	P1MerchantNo  string `json:"p1_MerchantNo" label:"商户编号;商户在支付平台系统的唯一身份标识;是"`
	P2OrderNo     string `json:"p2_OrderNo" label:"商户订单号;商户系统提交的唯一订单号。仅支持由英文字母、阿拉伯数字、下划线(英文符号“_”)组成的订单号传输;是"`
	P3Amount      string `json:"p3_Amount" label:"订单金额;单位:元，精确到分，保留两位小数。例如：10.23。;是"`
	P4Cur         string `json:"p4_Cur" label:"交易币种;默认设置为1（代表人民币）;是"`
	P5ProductName string `json:"p5_ProductName" label:"商品名称;用于支付时显示在支付平台网关上的订单产品信息;是"`
	P6ProductDesc string `json:"p6_ProductDesc" label:"商品描述;对商品信息进行描述;否"`
	P7Mp          string `json:"p7_Mp" label:"公用回传参数;如果商户请求时传递了该参数，则返回给商户时会原值传回;否"`
	P9NotifyUrl   string `json:"p9_NotifyUrl" label:"服务器异步通知地址;汇聚支付系统主动通知商户网站里指定的 http 地址。
异步通知地址需按：
1.AB|notifyUrl 的规则上送才会返回用户标识和平台优惠金额；
2.云闪付 CD|notifyUrl 的规则上才会返回用户支付的卡类型;是"`
	Q1FrpCode          string `json:"q1_FrpCode" label:"交易类型;可见md模型里提供的;是"`
	Q2MerchantBankCode string `json:"q2_MerchantBankCode" label:"银行商户编码;非必填;否"`
	Q4IsShowPic        string `json:"q4_IsShowPic" label:"是否展示图片;默认为空,不输出图片；填1表示输出图片，仅交易类型为主扫时可用（即当q1_FrpCode=ALIPAY_NATIVE、WEIXIN_NATIVE、JD_NATIVE、QQ_NATIVE、UNIONPAY_NATIVE、BAIDU_NATIVE、SUNING_NATIVE）;否"`
	Q5OpenId           string `json:"q5_OpenId" label:"微信Openid;	
公众号获取用户Openid,公众号支付商户及微信小程序商户必填（即当q1_FrpCode=WEIXIN_GZH、WEIXIN_XCX）;否"`
	Q6AuthCode string `json:"q6_AuthCode" label:"	
付款码数字;付款码数字被扫支付必填（即当q1_FrpCode= ALIPAY_CARD、WEIXIN_CARD、JD_CARD、QQ_CARD、UNIONPAY_CARD;否"`
	Q7AppId      string `json:"q7_AppId" label:"APPID;微信公众号、微信小程序、微信App、微信app+支付必填（即当q1_FrpCode= WEIXIN_GZH、WEIXIN_XCX、WEIXIN_APP3、WEIXIN_H5_PLUS【对应报备小程序appid】）;否"`
	Q8TerminalNo string `json:"q8_TerminalNo" label:"	
终端设备号;	
通过终端信息采集接口获取，由汇聚生成。微信/支付宝被扫支付必填（即当q1_FrpCode= ALIPAY_CARD、WEIXIN_CARD）;否"`
	Q9TransactionModel string `json:"q9_TransactionModel" label:"支付宝H5模式;支付宝H5选填，默认为空

1.模式一：当 q9_TransactionModel = MODEL1或为空时，有应答参数返回，rc_Result中返回html，需进行重定向跳转；2.模式二：当 q9_TransactionModel = MODEL2时，直接跳转链接，不返回应答参数。;否"`
	QATradeMerchantNo string `json:"qa_TradeMerchantNo" label:"报备商户号;请填写报备产品后返回的报备商户号;是"`
	QBbuyerId         string `json:"qb_buyerId" label:"买家的支付宝唯一用户号;支付宝服务窗支付必填（即当q1_FrpCode=ALIPAY_FWC ）（买家的支付宝唯一用户号（2088开头16位纯数字））;否"`
	QJDJPlan          string `json:"qj_DJPlan" label:"点金计划;该字段参数值为JSON串;否"`
	QKDisablePayModel string `json:"qk_DisablePayModel" label:"禁用支付方式;目前仅支持使用微信和支付宝支付时可禁用某些方式，详细枚举值见附录;否"`
	QLTerminalIp      string `json:"ql_TerminalIp" label:"终端设备IP;	
商户端终端设备 IP 地址。微信/支付宝被扫支付必填（即当q1_FrpCode= ALIPAY_CARD、WEIXIN_CARD）;否"`
	Hmac string `json:"hmac" label:"签名数据;参见签名机制;是"`
}

type JoinPayResponse struct {
	R7TrxNo            string `json:"r7_TrxNo"`
	RbCodeMsg          string `json:"rb_CodeMsg"`
	R2OrderNo          string `json:"r2_OrderNo"`
	R3Amount           string `json:"r3_Amount"`
	R6FrpCode          string `json:"r6_FrpCode"`
	RcResult           string `json:"rc_Result"`
	RaCode             int    `json:"ra_Code"`
	Hmac               string `json:"hmac"`
	RdPic              string `json:"rd_Pic"`
	R4Cur              string `json:"r4_Cur"`
	R5Mp               string `json:"r5_Mp"`
	R8MerchantBankCode string `json:"r8_MerchantBankCode"`
	R0Version          string `json:"r0_Version"`
	R1MerchantNo       string `json:"r1_MerchantNo"`
}

type JoinPayResponseWeChatRcResult struct {
	OrderNo     string `json:"order_no"`
	TrxNo       string `json:"trx_no"`
	PayeeName   string `json:"payee_name"`
	OriginalID  string `json:"original_id"`
	AppID       string `json:"app_id"`
	ProductName string `json:"product_name"`
	OrderAmout  string `json:"order_amout"`
}

type JoinPayCallBack struct {
	R1MerchantNo     string `json:"r1_MerchantNo" form:"r1_MerchantNo"`
	R2OrderNo        string `json:"r2_OrderNo" form:"r2_OrderNo"`
	R3Amount         string `json:"r3_Amount" form:"r3_Amount"`
	R4Cur            string `json:"r4_Cur" form:"r4_Cur"`
	R5Mp             string `json:"r5_Mp" form:"r5_Mp"`
	R6Status         int    `json:"r6_Status" form:"r6_Status"`
	R7TrxNo          string `json:"r7_TrxNo" form:"r7_TrxNo"`
	R8BankOrderNo    string `json:"r8_BankOrderNo" form:"r8_BankOrderNo"`
	R9BankTrxNo      string `json:"r9_BankTrxNo" form:"r9_BankTrxNo"`
	RaPayTime        string `json:"ra_PayTime" form:"ra_PayTime"`
	RbDealTime       string `json:"rb_DealTime" form:"rb_DealTime"`
	RcBankCode       string `json:"rc_BankCode" form:"rc_BankCode"`
	RdOpenId         string `json:"rd_OpenId" form:"rd_OpenId"`
	ReDiscountAmount string `json:"re_DiscountAmount" form:"re_DiscountAmount"`
	RhcardType       string `json:"rh_cardType" form:"rh_cardType"`
	Hmac             string `json:"hmac" form:"hmac"`
}
