package md

type KuDianWxPayParams struct {
	AppId       string `json:"app_id"`
	OpenId      string `json:"open_id"`
	OutTradeNo  string `json:"out_trade_no"`
	Description string `json:"description"`
	NotifyUrl   string `json:"notify_url"`
	TotalAmount string `json:"total_amount" binding:"required"`
	Attach      string `json:"attach" binding:"required"`
	MustParams  struct {
		ShopId          string `json:"shop_id"`
		KuDianMchId     string `json:"ku_dian_mch_id"`
		KuDianSecretKey string `json:"ku_dian_secret_key"`
	} `json:"must_params"`
}

type KuDianAliAppPayParams struct {
	OutTradeNo  string `json:"out_trade_no"`
	Description string `json:"description"`
	NotifyUrl   string `json:"notify_url"`
	UserId      string `json:"user_id"`
	TotalAmount string `json:"total_amount" binding:"required"`
	Attach      string `json:"attach" binding:"required"`
	TradeType   string `json:"trade_type"`
	SenceInfo   struct {
		WapUrl    string `json:"wap_url"`
		WapName   string `json:"wap_name"`
		ReturnUrl string `json:"return_url"`
	} `json:"sence_info"`
	MustParams struct {
		ShopId          string `json:"shop_id"`
		KuDianMchId     string `json:"ku_dian_mch_id"`
		KuDianSecretKey string `json:"ku_dian_secret_key"`
	} `json:"must_params"`
}

type MakePayParamsByKuDian struct {
	RequestUrl string      `json:"request_url"`
	Params     interface{} `json:"params"`
}

const (
	WX_APPLET_PAY_URL                                 = "zy-base-widget-sub/pages/cashier/cashier?unique_identifier="
	WX_APP_TO_APPLET_PAY_UNIQUE_IDENTIFIER            = "%s:wx_app_to_applet_pay_unique_identifier:%s:%s" // 酷点支付 - App跳转小程序支付 (mid + store_id + 纳秒时间戳)
	WX_APP_TO_APPLET_PAY_UNIQUE_IDENTIFIER_CACHE_TIME = 60 * 10                                           //缓存10分钟
)

// ###########################################  酷点支付 - 回调结构体 ###############################################

type KuDianPayCallback struct {
	Code   int    `json:"code"`
	Msg    string `json:"msg"`
	Result string `json:"result"`
}

type KuDianPayCallbackResp struct {
	MchId         string `json:"mch_id"`         //商户id
	PayNo         string `json:"pay_no"`         //聚合支付订单号
	OutTradeNo    string `json:"out_trade_no"`   //业务系统订单号
	TransactionId string `json:"transaction_id"` //支付平台交易流水号。微信、支付宝、云闪付等用户支付使用的平台返回流水号
	Fee           int    `json:"fee"`            //交易总额，单位：分
	ReceivedFee   int    `json:"received_fee"`   //商户实收金额，单位：分
	PayTime       string `json:"pay_time"`       //支付时间，格式"yyyy-MM-dd HH:mm:ss"
	Payment       string `json:"payment"`        //支付方式
	Body          string `json:"body"`           //支付简要描述
	Status        int    `json:"status"`         //支付状态
	Attach        string `json:"attach"`         //附加信息
}
